/**
 * output package name
 */
package com.kingdee.eas.custom.ats.client;

import org.apache.log4j.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.border.*;
import javax.swing.BorderFactory;
import javax.swing.event.*;
import javax.swing.KeyStroke;

import com.kingdee.bos.ctrl.swing.*;
import com.kingdee.bos.ctrl.kdf.table.*;
import com.kingdee.bos.ctrl.kdf.data.event.*;
import com.kingdee.bos.dao.*;
import com.kingdee.bos.dao.query.*;
import com.kingdee.bos.metadata.*;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.ui.face.*;
import com.kingdee.bos.ui.util.ResourceBundleHelper;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.bos.service.ServiceContext;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.util.enums.EnumUtils;
import com.kingdee.bos.ui.face.UIRuleUtil;
import com.kingdee.bos.ctrl.swing.event.*;
import com.kingdee.bos.ctrl.kdf.table.event.*;
import com.kingdee.bos.ctrl.extendcontrols.*;
import com.kingdee.bos.ctrl.kdf.util.render.*;
import com.kingdee.bos.ui.face.IItemAction;
import com.kingdee.eas.framework.batchHandler.RequestContext;
import com.kingdee.bos.ui.util.IUIActionPostman;
import com.kingdee.bos.appframework.client.servicebinding.ActionProxyFactory;
import com.kingdee.bos.appframework.uistatemanage.ActionStateConst;
import com.kingdee.bos.appframework.validator.ValidateHelper;
import com.kingdee.bos.appframework.uip.UINavigator;


/**
 * output class name
 */
public abstract class AbstractAtsLeaveBillDetailSameEditUI extends com.kingdee.eas.framework.client.EditUI
{
    private static final Logger logger = CoreUIObject.getLogger(AbstractAtsLeaveBillDetailSameEditUI.class);
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer kDLabelContainer1;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer kDLabelContainer2;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer kDLabelContainer3;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer kDLabelContainer4;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contleavebill;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contleavebillEntry;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contleaveDate;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contleaveLenght;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contleaveUnit;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contpolicy;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contholidayResult;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contpreTime;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contnextTime;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contattAdminOrgUnit;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contproposer;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contadminOrgUnit;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contposition;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer conthrOrgUnit;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtNumber;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizMultiLangBox txtName;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtSimpleName;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizMultiLangBox txtDescription;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtleavebill;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtleavebillEntry;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker pkleaveDate;
    protected com.kingdee.bos.ctrl.swing.KDFormattedTextField txtleaveLenght;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtleaveUnit;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtpolicy;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtholidayResult;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtpreTime;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtnextTime;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtattAdminOrgUnit;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtproposer;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtadminOrgUnit;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtposition;
    protected com.kingdee.bos.ctrl.swing.KDTextField txthrOrgUnit;
    protected com.kingdee.eas.custom.ats.AtsLeaveBillDetailSameInfo editData = null;
    /**
     * output class constructor
     */
    public AbstractAtsLeaveBillDetailSameEditUI() throws Exception
    {
        super();
        this.defaultObjectName = "editData";
        jbInit();
        
        initUIP();
    }

    /**
     * output jbInit method
     */
    private void jbInit() throws Exception
    {
        this.resHelper = new ResourceBundleHelper(AbstractAtsLeaveBillDetailSameEditUI.class.getName());
        this.setUITitle(resHelper.getString("this.title"));
        this.kDLabelContainer1 = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.kDLabelContainer2 = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.kDLabelContainer3 = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.kDLabelContainer4 = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contleavebill = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contleavebillEntry = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contleaveDate = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contleaveLenght = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contleaveUnit = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contpolicy = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contholidayResult = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contpreTime = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contnextTime = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contattAdminOrgUnit = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contproposer = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contadminOrgUnit = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contposition = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.conthrOrgUnit = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.txtNumber = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txtName = new com.kingdee.bos.ctrl.extendcontrols.KDBizMultiLangBox();
        this.txtSimpleName = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txtDescription = new com.kingdee.bos.ctrl.extendcontrols.KDBizMultiLangBox();
        this.txtleavebill = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txtleavebillEntry = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.pkleaveDate = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.txtleaveLenght = new com.kingdee.bos.ctrl.swing.KDFormattedTextField();
        this.txtleaveUnit = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txtpolicy = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txtholidayResult = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txtpreTime = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txtnextTime = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txtattAdminOrgUnit = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txtproposer = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txtadminOrgUnit = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txtposition = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txthrOrgUnit = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.kDLabelContainer1.setName("kDLabelContainer1");
        this.kDLabelContainer2.setName("kDLabelContainer2");
        this.kDLabelContainer3.setName("kDLabelContainer3");
        this.kDLabelContainer4.setName("kDLabelContainer4");
        this.contleavebill.setName("contleavebill");
        this.contleavebillEntry.setName("contleavebillEntry");
        this.contleaveDate.setName("contleaveDate");
        this.contleaveLenght.setName("contleaveLenght");
        this.contleaveUnit.setName("contleaveUnit");
        this.contpolicy.setName("contpolicy");
        this.contholidayResult.setName("contholidayResult");
        this.contpreTime.setName("contpreTime");
        this.contnextTime.setName("contnextTime");
        this.contattAdminOrgUnit.setName("contattAdminOrgUnit");
        this.contproposer.setName("contproposer");
        this.contadminOrgUnit.setName("contadminOrgUnit");
        this.contposition.setName("contposition");
        this.conthrOrgUnit.setName("conthrOrgUnit");
        this.txtNumber.setName("txtNumber");
        this.txtName.setName("txtName");
        this.txtSimpleName.setName("txtSimpleName");
        this.txtDescription.setName("txtDescription");
        this.txtleavebill.setName("txtleavebill");
        this.txtleavebillEntry.setName("txtleavebillEntry");
        this.pkleaveDate.setName("pkleaveDate");
        this.txtleaveLenght.setName("txtleaveLenght");
        this.txtleaveUnit.setName("txtleaveUnit");
        this.txtpolicy.setName("txtpolicy");
        this.txtholidayResult.setName("txtholidayResult");
        this.txtpreTime.setName("txtpreTime");
        this.txtnextTime.setName("txtnextTime");
        this.txtattAdminOrgUnit.setName("txtattAdminOrgUnit");
        this.txtproposer.setName("txtproposer");
        this.txtadminOrgUnit.setName("txtadminOrgUnit");
        this.txtposition.setName("txtposition");
        this.txthrOrgUnit.setName("txthrOrgUnit");
        // CoreUI		
        this.btnPrint.setVisible(false);		
        this.btnPrintPreview.setVisible(false);		
        this.menuItemPrint.setVisible(false);		
        this.menuItemPrintPreview.setVisible(false);
        // kDLabelContainer1		
        this.kDLabelContainer1.setBoundLabelText(resHelper.getString("kDLabelContainer1.boundLabelText"));		
        this.kDLabelContainer1.setBoundLabelLength(100);		
        this.kDLabelContainer1.setBoundLabelUnderline(true);
        // kDLabelContainer2		
        this.kDLabelContainer2.setBoundLabelText(resHelper.getString("kDLabelContainer2.boundLabelText"));		
        this.kDLabelContainer2.setBoundLabelLength(100);		
        this.kDLabelContainer2.setBoundLabelUnderline(true);
        // kDLabelContainer3		
        this.kDLabelContainer3.setBoundLabelText(resHelper.getString("kDLabelContainer3.boundLabelText"));		
        this.kDLabelContainer3.setBoundLabelLength(100);		
        this.kDLabelContainer3.setBoundLabelUnderline(true);
        // kDLabelContainer4		
        this.kDLabelContainer4.setBoundLabelText(resHelper.getString("kDLabelContainer4.boundLabelText"));		
        this.kDLabelContainer4.setBoundLabelLength(100);		
        this.kDLabelContainer4.setBoundLabelUnderline(true);		
        this.kDLabelContainer4.setBoundLabelAlignment(7);		
        this.kDLabelContainer4.setVisible(true);
        // contleavebill		
        this.contleavebill.setBoundLabelText(resHelper.getString("contleavebill.boundLabelText"));		
        this.contleavebill.setBoundLabelLength(100);		
        this.contleavebill.setBoundLabelUnderline(true);		
        this.contleavebill.setVisible(true);
        // contleavebillEntry		
        this.contleavebillEntry.setBoundLabelText(resHelper.getString("contleavebillEntry.boundLabelText"));		
        this.contleavebillEntry.setBoundLabelLength(100);		
        this.contleavebillEntry.setBoundLabelUnderline(true);		
        this.contleavebillEntry.setVisible(true);
        // contleaveDate		
        this.contleaveDate.setBoundLabelText(resHelper.getString("contleaveDate.boundLabelText"));		
        this.contleaveDate.setBoundLabelLength(100);		
        this.contleaveDate.setBoundLabelUnderline(true);		
        this.contleaveDate.setVisible(true);
        // contleaveLenght		
        this.contleaveLenght.setBoundLabelText(resHelper.getString("contleaveLenght.boundLabelText"));		
        this.contleaveLenght.setBoundLabelLength(100);		
        this.contleaveLenght.setBoundLabelUnderline(true);		
        this.contleaveLenght.setVisible(true);
        // contleaveUnit		
        this.contleaveUnit.setBoundLabelText(resHelper.getString("contleaveUnit.boundLabelText"));		
        this.contleaveUnit.setBoundLabelLength(100);		
        this.contleaveUnit.setBoundLabelUnderline(true);		
        this.contleaveUnit.setVisible(true);
        // contpolicy		
        this.contpolicy.setBoundLabelText(resHelper.getString("contpolicy.boundLabelText"));		
        this.contpolicy.setBoundLabelLength(100);		
        this.contpolicy.setBoundLabelUnderline(true);		
        this.contpolicy.setVisible(true);
        // contholidayResult		
        this.contholidayResult.setBoundLabelText(resHelper.getString("contholidayResult.boundLabelText"));		
        this.contholidayResult.setBoundLabelLength(100);		
        this.contholidayResult.setBoundLabelUnderline(true);		
        this.contholidayResult.setVisible(true);
        // contpreTime		
        this.contpreTime.setBoundLabelText(resHelper.getString("contpreTime.boundLabelText"));		
        this.contpreTime.setBoundLabelLength(100);		
        this.contpreTime.setBoundLabelUnderline(true);		
        this.contpreTime.setVisible(true);
        // contnextTime		
        this.contnextTime.setBoundLabelText(resHelper.getString("contnextTime.boundLabelText"));		
        this.contnextTime.setBoundLabelLength(100);		
        this.contnextTime.setBoundLabelUnderline(true);		
        this.contnextTime.setVisible(true);
        // contattAdminOrgUnit		
        this.contattAdminOrgUnit.setBoundLabelText(resHelper.getString("contattAdminOrgUnit.boundLabelText"));		
        this.contattAdminOrgUnit.setBoundLabelLength(100);		
        this.contattAdminOrgUnit.setBoundLabelUnderline(true);		
        this.contattAdminOrgUnit.setVisible(true);
        // contproposer		
        this.contproposer.setBoundLabelText(resHelper.getString("contproposer.boundLabelText"));		
        this.contproposer.setBoundLabelLength(100);		
        this.contproposer.setBoundLabelUnderline(true);		
        this.contproposer.setVisible(true);
        // contadminOrgUnit		
        this.contadminOrgUnit.setBoundLabelText(resHelper.getString("contadminOrgUnit.boundLabelText"));		
        this.contadminOrgUnit.setBoundLabelLength(100);		
        this.contadminOrgUnit.setBoundLabelUnderline(true);		
        this.contadminOrgUnit.setVisible(true);
        // contposition		
        this.contposition.setBoundLabelText(resHelper.getString("contposition.boundLabelText"));		
        this.contposition.setBoundLabelLength(100);		
        this.contposition.setBoundLabelUnderline(true);		
        this.contposition.setVisible(true);
        // conthrOrgUnit		
        this.conthrOrgUnit.setBoundLabelText(resHelper.getString("conthrOrgUnit.boundLabelText"));		
        this.conthrOrgUnit.setBoundLabelLength(100);		
        this.conthrOrgUnit.setBoundLabelUnderline(true);		
        this.conthrOrgUnit.setVisible(true);
        // txtNumber		
        this.txtNumber.setMaxLength(80);
        // txtName
        // txtSimpleName		
        this.txtSimpleName.setMaxLength(80);
        // txtDescription
        // txtleavebill		
        this.txtleavebill.setVisible(true);		
        this.txtleavebill.setHorizontalAlignment(2);		
        this.txtleavebill.setMaxLength(255);		
        this.txtleavebill.setRequired(false);
        // txtleavebillEntry		
        this.txtleavebillEntry.setVisible(true);		
        this.txtleavebillEntry.setHorizontalAlignment(2);		
        this.txtleavebillEntry.setMaxLength(255);		
        this.txtleavebillEntry.setRequired(false);
        // pkleaveDate		
        this.pkleaveDate.setVisible(true);		
        this.pkleaveDate.setRequired(false);
        // txtleaveLenght		
        this.txtleaveLenght.setVisible(true);		
        this.txtleaveLenght.setHorizontalAlignment(2);		
        this.txtleaveLenght.setDataType(1);		
        this.txtleaveLenght.setSupportedEmpty(true);		
        this.txtleaveLenght.setMinimumValue( new java.math.BigDecimal("-1.0E18"));		
        this.txtleaveLenght.setMaximumValue( new java.math.BigDecimal("1.0E18"));		
        this.txtleaveLenght.setPrecision(10);		
        this.txtleaveLenght.setRequired(false);
        // txtleaveUnit		
        this.txtleaveUnit.setVisible(true);		
        this.txtleaveUnit.setHorizontalAlignment(2);		
        this.txtleaveUnit.setMaxLength(100);		
        this.txtleaveUnit.setRequired(false);
        // txtpolicy		
        this.txtpolicy.setVisible(true);		
        this.txtpolicy.setHorizontalAlignment(2);		
        this.txtpolicy.setMaxLength(255);		
        this.txtpolicy.setRequired(false);
        // txtholidayResult		
        this.txtholidayResult.setVisible(true);		
        this.txtholidayResult.setHorizontalAlignment(2);		
        this.txtholidayResult.setMaxLength(255);		
        this.txtholidayResult.setRequired(false);
        // txtpreTime		
        this.txtpreTime.setVisible(true);		
        this.txtpreTime.setHorizontalAlignment(2);		
        this.txtpreTime.setMaxLength(100);		
        this.txtpreTime.setRequired(false);
        // txtnextTime		
        this.txtnextTime.setVisible(true);		
        this.txtnextTime.setHorizontalAlignment(2);		
        this.txtnextTime.setMaxLength(100);		
        this.txtnextTime.setRequired(false);
        // txtattAdminOrgUnit		
        this.txtattAdminOrgUnit.setVisible(true);		
        this.txtattAdminOrgUnit.setHorizontalAlignment(2);		
        this.txtattAdminOrgUnit.setMaxLength(255);		
        this.txtattAdminOrgUnit.setRequired(false);
        // txtproposer		
        this.txtproposer.setVisible(true);		
        this.txtproposer.setHorizontalAlignment(2);		
        this.txtproposer.setMaxLength(255);		
        this.txtproposer.setRequired(false);
        // txtadminOrgUnit		
        this.txtadminOrgUnit.setVisible(true);		
        this.txtadminOrgUnit.setHorizontalAlignment(2);		
        this.txtadminOrgUnit.setMaxLength(255);		
        this.txtadminOrgUnit.setRequired(false);
        // txtposition		
        this.txtposition.setVisible(true);		
        this.txtposition.setHorizontalAlignment(2);		
        this.txtposition.setMaxLength(255);		
        this.txtposition.setRequired(false);
        // txthrOrgUnit		
        this.txthrOrgUnit.setVisible(true);		
        this.txthrOrgUnit.setHorizontalAlignment(2);		
        this.txthrOrgUnit.setMaxLength(255);		
        this.txthrOrgUnit.setRequired(false);
        this.setFocusTraversalPolicy(new com.kingdee.bos.ui.UIFocusTraversalPolicy(new java.awt.Component[] {txtleavebill,txtleavebillEntry,pkleaveDate,txtleaveLenght,txtleaveUnit,txtpolicy,txtholidayResult,txtpreTime,txtnextTime,txtattAdminOrgUnit,txtproposer,txtadminOrgUnit,txtposition,txthrOrgUnit}));
        this.setFocusCycleRoot(true);
		//Register control's property binding
		registerBindings();
		registerUIState();


    }

	public com.kingdee.bos.ctrl.swing.KDToolBar[] getUIMultiToolBar(){
		java.util.List list = new java.util.ArrayList();
		com.kingdee.bos.ctrl.swing.KDToolBar[] bars = super.getUIMultiToolBar();
		if (bars != null) {
			list.addAll(java.util.Arrays.asList(bars));
		}
		return (com.kingdee.bos.ctrl.swing.KDToolBar[])list.toArray(new com.kingdee.bos.ctrl.swing.KDToolBar[list.size()]);
	}




    /**
     * output initUIContentLayout method
     */
    public void initUIContentLayout()
    {
        this.setBounds(new Rectangle(0, 0, 1013, 629));
        this.setLayout(null);
        kDLabelContainer1.setBounds(new Rectangle(102, 44, 270, 19));
        this.add(kDLabelContainer1, null);
        kDLabelContainer2.setBounds(new Rectangle(102, 81, 270, 19));
        this.add(kDLabelContainer2, null);
        kDLabelContainer3.setBounds(new Rectangle(102, 118, 270, 19));
        this.add(kDLabelContainer3, null);
        kDLabelContainer4.setBounds(new Rectangle(102, 155, 270, 19));
        this.add(kDLabelContainer4, null);
        contleavebill.setBounds(new Rectangle(9, 21, 270, 19));
        this.add(contleavebill, null);
        contleavebillEntry.setBounds(new Rectangle(408, 34, 270, 19));
        this.add(contleavebillEntry, null);
        contleaveDate.setBounds(new Rectangle(375, 150, 270, 19));
        this.add(contleaveDate, null);
        contleaveLenght.setBounds(new Rectangle(378, 60, 270, 19));
        this.add(contleaveLenght, null);
        contleaveUnit.setBounds(new Rectangle(401, 108, 270, 19));
        this.add(contleaveUnit, null);
        contpolicy.setBounds(new Rectangle(302, 262, 270, 19));
        this.add(contpolicy, null);
        contholidayResult.setBounds(new Rectangle(62, 238, 270, 19));
        this.add(contholidayResult, null);
        contpreTime.setBounds(new Rectangle(79, 193, 270, 19));
        this.add(contpreTime, null);
        contnextTime.setBounds(new Rectangle(312, 202, 270, 19));
        this.add(contnextTime, null);
        contattAdminOrgUnit.setBounds(new Rectangle(109, 293, 270, 19));
        this.add(contattAdminOrgUnit, null);
        contproposer.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contproposer, null);
        contadminOrgUnit.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contadminOrgUnit, null);
        contposition.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contposition, null);
        conthrOrgUnit.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(conthrOrgUnit, null);
        //kDLabelContainer1
        kDLabelContainer1.setBoundEditor(txtNumber);
        //kDLabelContainer2
        kDLabelContainer2.setBoundEditor(txtName);
        //kDLabelContainer3
        kDLabelContainer3.setBoundEditor(txtSimpleName);
        //kDLabelContainer4
        kDLabelContainer4.setBoundEditor(txtDescription);
        //contleavebill
        contleavebill.setBoundEditor(txtleavebill);
        //contleavebillEntry
        contleavebillEntry.setBoundEditor(txtleavebillEntry);
        //contleaveDate
        contleaveDate.setBoundEditor(pkleaveDate);
        //contleaveLenght
        contleaveLenght.setBoundEditor(txtleaveLenght);
        //contleaveUnit
        contleaveUnit.setBoundEditor(txtleaveUnit);
        //contpolicy
        contpolicy.setBoundEditor(txtpolicy);
        //contholidayResult
        contholidayResult.setBoundEditor(txtholidayResult);
        //contpreTime
        contpreTime.setBoundEditor(txtpreTime);
        //contnextTime
        contnextTime.setBoundEditor(txtnextTime);
        //contattAdminOrgUnit
        contattAdminOrgUnit.setBoundEditor(txtattAdminOrgUnit);
        //contproposer
        contproposer.setBoundEditor(txtproposer);
        //contadminOrgUnit
        contadminOrgUnit.setBoundEditor(txtadminOrgUnit);
        //contposition
        contposition.setBoundEditor(txtposition);
        //conthrOrgUnit
        conthrOrgUnit.setBoundEditor(txthrOrgUnit);

    }


    /**
     * output initUIMenuBarLayout method
     */
    public void initUIMenuBarLayout()
    {
        this.menuBar.add(menuFile);
        this.menuBar.add(menuEdit);
        this.menuBar.add(MenuService);
        this.menuBar.add(menuView);
        this.menuBar.add(menuBiz);
        this.menuBar.add(menuTool);
        this.menuBar.add(menuHelp);
        //menuFile
        menuFile.add(menuItemAddNew);
        menuFile.add(kDSeparator1);
        menuFile.add(menuItemCloudFeed);
        menuFile.add(menuItemSave);
        menuFile.add(menuItemCloudScreen);
        menuFile.add(menuItemSubmit);
        menuFile.add(menuItemCloudShare);
        menuFile.add(menuSubmitOption);
        menuFile.add(kdSeparatorFWFile1);
        menuFile.add(rMenuItemSubmit);
        menuFile.add(rMenuItemSubmitAndAddNew);
        menuFile.add(rMenuItemSubmitAndPrint);
        menuFile.add(separatorFile1);
        menuFile.add(MenuItemAttachment);
        menuFile.add(kDSeparator2);
        menuFile.add(menuItemPageSetup);
        menuFile.add(menuItemPrint);
        menuFile.add(menuItemPrintPreview);
        menuFile.add(kDSeparator3);
        menuFile.add(menuItemExitCurrent);
        //menuSubmitOption
        menuSubmitOption.add(chkMenuItemSubmitAndAddNew);
        menuSubmitOption.add(chkMenuItemSubmitAndPrint);
        //menuEdit
        menuEdit.add(menuItemCopy);
        menuEdit.add(menuItemEdit);
        menuEdit.add(menuItemRemove);
        menuEdit.add(kDSeparator4);
        menuEdit.add(menuItemReset);
        //MenuService
        MenuService.add(MenuItemKnowStore);
        MenuService.add(MenuItemAnwser);
        MenuService.add(SepratorService);
        MenuService.add(MenuItemRemoteAssist);
        //menuView
        menuView.add(menuItemFirst);
        menuView.add(menuItemPre);
        menuView.add(menuItemNext);
        menuView.add(menuItemLast);
        //menuBiz
        menuBiz.add(menuItemCancelCancel);
        menuBiz.add(menuItemCancel);
        //menuTool
        menuTool.add(menuItemMsgFormat);
        menuTool.add(menuItemSendMessage);
        menuTool.add(menuItemCalculator);
        menuTool.add(menuItemToolBarCustom);
        //menuHelp
        menuHelp.add(menuItemHelp);
        menuHelp.add(kDSeparator12);
        menuHelp.add(menuItemRegPro);
        menuHelp.add(menuItemPersonalSite);
        menuHelp.add(helpseparatorDiv);
        menuHelp.add(menuitemProductval);
        menuHelp.add(kDSeparatorProduct);
        menuHelp.add(menuItemAbout);

    }

    /**
     * output initUIToolBarLayout method
     */
    public void initUIToolBarLayout()
    {
        this.toolBar.add(btnAddNew);
        this.toolBar.add(btnCloud);
        this.toolBar.add(btnEdit);
        this.toolBar.add(btnXunTong);
        this.toolBar.add(btnReset);
        this.toolBar.add(kDSeparatorCloud);
        this.toolBar.add(btnSave);
        this.toolBar.add(btnSubmit);
        this.toolBar.add(btnCopy);
        this.toolBar.add(btnRemove);
        this.toolBar.add(btnAttachment);
        this.toolBar.add(separatorFW1);
        this.toolBar.add(btnPageSetup);
        this.toolBar.add(btnPrint);
        this.toolBar.add(btnPrintPreview);
        this.toolBar.add(separatorFW2);
        this.toolBar.add(btnFirst);
        this.toolBar.add(btnPre);
        this.toolBar.add(btnNext);
        this.toolBar.add(btnLast);
        this.toolBar.add(separatorFW3);
        this.toolBar.add(btnCancelCancel);
        this.toolBar.add(btnCancel);


    }

	//Regiester control's property binding.
	private void registerBindings(){
		dataBinder.registerBinding("number", String.class, this.txtNumber, "text");
		dataBinder.registerBinding("name", String.class, this.txtName, "_multiLangItem");
		dataBinder.registerBinding("simpleName", String.class, this.txtSimpleName, "text");
		dataBinder.registerBinding("description", String.class, this.txtDescription, "_multiLangItem");
		dataBinder.registerBinding("leavebill", String.class, this.txtleavebill, "text");
		dataBinder.registerBinding("leavebillEntry", String.class, this.txtleavebillEntry, "text");
		dataBinder.registerBinding("leaveDate", java.util.Date.class, this.pkleaveDate, "value");
		dataBinder.registerBinding("leaveLenght", java.math.BigDecimal.class, this.txtleaveLenght, "value");
		dataBinder.registerBinding("leaveUnit", String.class, this.txtleaveUnit, "text");
		dataBinder.registerBinding("policy", String.class, this.txtpolicy, "text");
		dataBinder.registerBinding("holidayResult", String.class, this.txtholidayResult, "text");
		dataBinder.registerBinding("preTime", String.class, this.txtpreTime, "text");
		dataBinder.registerBinding("nextTime", String.class, this.txtnextTime, "text");
		dataBinder.registerBinding("attAdminOrgUnit", String.class, this.txtattAdminOrgUnit, "text");
		dataBinder.registerBinding("proposer", String.class, this.txtproposer, "text");
		dataBinder.registerBinding("adminOrgUnit", String.class, this.txtadminOrgUnit, "text");
		dataBinder.registerBinding("position", String.class, this.txtposition, "text");
		dataBinder.registerBinding("hrOrgUnit", String.class, this.txthrOrgUnit, "text");		
	}
	//Regiester UI State
	private void registerUIState(){
	        getActionManager().registerUIState(STATUS_ADDNEW, this.txtName, ActionStateConst.ENABLED);
	        getActionManager().registerUIState(STATUS_ADDNEW, this.txtDescription, ActionStateConst.ENABLED);
	        getActionManager().registerUIState(STATUS_ADDNEW, this.txtNumber, ActionStateConst.ENABLED);
	        getActionManager().registerUIState(STATUS_ADDNEW, this.txtSimpleName, ActionStateConst.ENABLED);
	        getActionManager().registerUIState(STATUS_EDIT, this.txtName, ActionStateConst.ENABLED);
	        getActionManager().registerUIState(STATUS_EDIT, this.txtDescription, ActionStateConst.ENABLED);
	        getActionManager().registerUIState(STATUS_EDIT, this.txtNumber, ActionStateConst.ENABLED);
	        getActionManager().registerUIState(STATUS_EDIT, this.txtSimpleName, ActionStateConst.ENABLED);					 	        		
	        getActionManager().registerUIState(STATUS_VIEW, this.txtName, ActionStateConst.DISABLED);					 	        		
	        getActionManager().registerUIState(STATUS_VIEW, this.txtDescription, ActionStateConst.DISABLED);					 	        		
	        getActionManager().registerUIState(STATUS_VIEW, this.txtNumber, ActionStateConst.DISABLED);					 	        		
	        getActionManager().registerUIState(STATUS_VIEW, this.txtSimpleName, ActionStateConst.DISABLED);		
	}
	public String getUIHandlerClassName() {
	    return "com.kingdee.eas.custom.ats.app.AtsLeaveBillDetailSameEditUIHandler";
	}
	public IUIActionPostman prepareInit() {
		IUIActionPostman clientHanlder = super.prepareInit();
		if (clientHanlder != null) {
			RequestContext request = new RequestContext();
    		request.setClassName(getUIHandlerClassName());
			clientHanlder.setRequestContext(request);
		}
		return clientHanlder;
    }
	
	public boolean isPrepareInit() {
    	return false;
    }
    protected void initUIP() {
        super.initUIP();
    }


    /**
     * output onShow method
     */
    public void onShow() throws Exception
    {
        super.onShow();
        this.txtleavebill.requestFocusInWindow();
    }

	
	

    /**
     * output setDataObject method
     */
    public void setDataObject(IObjectValue dataObject)
    {
        IObjectValue ov = dataObject;        	    	
        super.setDataObject(ov);
        this.editData = (com.kingdee.eas.custom.ats.AtsLeaveBillDetailSameInfo)ov;
    }
    protected void removeByPK(IObjectPK pk) throws Exception {
    	IObjectValue editData = this.editData;
    	super.removeByPK(pk);
    	recycleNumberByOrg(editData,"NONE",editData.getString("number"));
    }
    
    protected void recycleNumberByOrg(IObjectValue editData,String orgType,String number) {
        if (!StringUtils.isEmpty(number))
        {
            try {
            	String companyID = null;            
            	com.kingdee.eas.base.codingrule.ICodingRuleManager iCodingRuleManager = com.kingdee.eas.base.codingrule.CodingRuleManagerFactory.getRemoteInstance();
				if(!com.kingdee.util.StringUtils.isEmpty(orgType) && !"NONE".equalsIgnoreCase(orgType) && com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType))!=null) {
					companyID =com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType)).getString("id");
				}
				else if (com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit() != null) {
					companyID = ((com.kingdee.eas.basedata.org.OrgUnitInfo)com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit()).getString("id");
            	}				
				if (!StringUtils.isEmpty(companyID) && iCodingRuleManager.isExist(editData, companyID) && iCodingRuleManager.isUseIntermitNumber(editData, companyID)) {
					iCodingRuleManager.recycleNumber(editData,companyID,number);					
				}
            }
            catch (Exception e)
            {
                handUIException(e);
            }
        }
    }
    protected void setAutoNumberByOrg(String orgType) {
    	if (editData == null) return;
		if (editData.getNumber() == null) {
            try {
            	String companyID = null;
				if(!com.kingdee.util.StringUtils.isEmpty(orgType) && !"NONE".equalsIgnoreCase(orgType) && com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType))!=null) {
					companyID = com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType)).getString("id");
				}
				else if (com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit() != null) {
					companyID = ((com.kingdee.eas.basedata.org.OrgUnitInfo)com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit()).getString("id");
            	}
				com.kingdee.eas.base.codingrule.ICodingRuleManager iCodingRuleManager = com.kingdee.eas.base.codingrule.CodingRuleManagerFactory.getRemoteInstance();
		        if (iCodingRuleManager.isExist(editData, companyID)) {
		            if (iCodingRuleManager.isAddView(editData, companyID)) {
		            	editData.setNumber(iCodingRuleManager.getNumber(editData,companyID));
		            }
	                txtNumber.setEnabled(false);
		        }
            }
            catch (Exception e) {
                handUIException(e);
                this.oldData = editData;
                com.kingdee.eas.util.SysUtil.abort();
            } 
        } 
        else {
            if (editData.getNumber().trim().length() > 0) {
                txtNumber.setText(editData.getNumber());
            }
        }
    }

    /**
     * output loadFields method
     */
    public void loadFields()
    {
        		setAutoNumberByOrg("NONE");
        dataBinder.loadFields();
    }
		protected void setOrgF7(KDBizPromptBox f7,com.kingdee.eas.basedata.org.OrgType orgType) throws Exception
		{
			com.kingdee.eas.basedata.org.client.f7.NewOrgUnitFilterInfoProducer oufip = new com.kingdee.eas.basedata.org.client.f7.NewOrgUnitFilterInfoProducer(orgType);
			oufip.getModel().setIsCUFilter(true);
			f7.setFilterInfoProducer(oufip);
		}

    /**
     * output storeFields method
     */
    public void storeFields()
    {
		dataBinder.storeFields();
    }

	/**
	 * ????????งต??
	 */
	protected void registerValidator() {
    	getValidateHelper().setCustomValidator( getValidator() );
		getValidateHelper().registerBindProperty("number", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("name", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("simpleName", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("description", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("leavebill", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("leavebillEntry", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("leaveDate", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("leaveLenght", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("leaveUnit", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("policy", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("holidayResult", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("preTime", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("nextTime", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("attAdminOrgUnit", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("proposer", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("adminOrgUnit", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("position", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("hrOrgUnit", ValidateHelper.ON_SAVE);    		
	}



    /**
     * output setOprtState method
     */
    public void setOprtState(String oprtType)
    {
        super.setOprtState(oprtType);
        if (STATUS_ADDNEW.equals(this.oprtState)) {
		            this.txtName.setEnabled(true);
		            this.txtDescription.setEnabled(true);
		            this.txtNumber.setEnabled(true);
		            this.txtSimpleName.setEnabled(true);
        } else if (STATUS_EDIT.equals(this.oprtState)) {
		            this.txtName.setEnabled(true);
		            this.txtDescription.setEnabled(true);
		            this.txtNumber.setEnabled(true);
		            this.txtSimpleName.setEnabled(true);
        } else if (STATUS_VIEW.equals(this.oprtState)) {
		            this.txtName.setEnabled(false);
		            this.txtDescription.setEnabled(false);
		            this.txtNumber.setEnabled(false);
		            this.txtSimpleName.setEnabled(false);
        }
    }

    /**
     * output getSelectors method
     */
    public SelectorItemCollection getSelectors()
    {
        SelectorItemCollection sic = new SelectorItemCollection();
		String selectorAll = System.getProperty("selector.all");
		if(StringUtils.isEmpty(selectorAll)){
			selectorAll = "true";
		}
        sic.add(new SelectorItemInfo("number"));
        sic.add(new SelectorItemInfo("name"));
        sic.add(new SelectorItemInfo("simpleName"));
        sic.add(new SelectorItemInfo("description"));
        sic.add(new SelectorItemInfo("leavebill"));
        sic.add(new SelectorItemInfo("leavebillEntry"));
        sic.add(new SelectorItemInfo("leaveDate"));
        sic.add(new SelectorItemInfo("leaveLenght"));
        sic.add(new SelectorItemInfo("leaveUnit"));
        sic.add(new SelectorItemInfo("policy"));
        sic.add(new SelectorItemInfo("holidayResult"));
        sic.add(new SelectorItemInfo("preTime"));
        sic.add(new SelectorItemInfo("nextTime"));
        sic.add(new SelectorItemInfo("attAdminOrgUnit"));
        sic.add(new SelectorItemInfo("proposer"));
        sic.add(new SelectorItemInfo("adminOrgUnit"));
        sic.add(new SelectorItemInfo("position"));
        sic.add(new SelectorItemInfo("hrOrgUnit"));
        return sic;
    }        

    /**
     * output getMetaDataPK method
     */
    public IMetaDataPK getMetaDataPK()
    {
        return new MetaDataPK("com.kingdee.eas.custom.ats.client", "AtsLeaveBillDetailSameEditUI");
    }

    /**
     * output getEditUIName method
     */
    protected String getEditUIName()
    {
        return com.kingdee.eas.custom.ats.client.AtsLeaveBillDetailSameEditUI.class.getName();
    }

    /**
     * output getBizInterface method
     */
    protected com.kingdee.eas.framework.ICoreBase getBizInterface() throws Exception
    {
        return com.kingdee.eas.custom.ats.AtsLeaveBillDetailSameFactory.getRemoteInstance();
    }

    /**
     * output createNewData method
     */
    protected IObjectValue createNewData()
    {
        com.kingdee.eas.custom.ats.AtsLeaveBillDetailSameInfo objectValue = new com.kingdee.eas.custom.ats.AtsLeaveBillDetailSameInfo();
        objectValue.setCreator((com.kingdee.eas.base.permission.UserInfo)(com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentUser()));		
        return objectValue;
    }



    /**
     * output getDetailTable method
     */
    protected KDTable getDetailTable() {        
        return null;
	}
    /**
     * output applyDefaultValue method
     */
    protected void applyDefaultValue(IObjectValue vo) {        
    }        
	protected void setFieldsNull(com.kingdee.bos.dao.AbstractObjectValue arg0) {
		super.setFieldsNull(arg0);
		arg0.put("number",null);
	}

}